// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from splsm_7:msg/SPLSM.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "splsm_7/msg/splsm.h"


#ifndef SPLSM_7__MSG__DETAIL__SPLSM__FUNCTIONS_H_
#define SPLSM_7__MSG__DETAIL__SPLSM__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "splsm_7/msg/rosidl_generator_c__visibility_control.h"

#include "splsm_7/msg/detail/splsm__struct.h"

/// Initialize msg/SPLSM message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * splsm_7__msg__SPLSM
 * )) before or use
 * splsm_7__msg__SPLSM__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_splsm_7
bool
splsm_7__msg__SPLSM__init(splsm_7__msg__SPLSM * msg);

/// Finalize msg/SPLSM message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_splsm_7
void
splsm_7__msg__SPLSM__fini(splsm_7__msg__SPLSM * msg);

/// Create msg/SPLSM message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * splsm_7__msg__SPLSM__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_splsm_7
splsm_7__msg__SPLSM *
splsm_7__msg__SPLSM__create();

/// Destroy msg/SPLSM message.
/**
 * It calls
 * splsm_7__msg__SPLSM__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_splsm_7
void
splsm_7__msg__SPLSM__destroy(splsm_7__msg__SPLSM * msg);

/// Check for msg/SPLSM message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_splsm_7
bool
splsm_7__msg__SPLSM__are_equal(const splsm_7__msg__SPLSM * lhs, const splsm_7__msg__SPLSM * rhs);

/// Copy a msg/SPLSM message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_splsm_7
bool
splsm_7__msg__SPLSM__copy(
  const splsm_7__msg__SPLSM * input,
  splsm_7__msg__SPLSM * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_splsm_7
const rosidl_type_hash_t *
splsm_7__msg__SPLSM__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_splsm_7
const rosidl_runtime_c__type_description__TypeDescription *
splsm_7__msg__SPLSM__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_splsm_7
const rosidl_runtime_c__type_description__TypeSource *
splsm_7__msg__SPLSM__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_splsm_7
const rosidl_runtime_c__type_description__TypeSource__Sequence *
splsm_7__msg__SPLSM__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/SPLSM messages.
/**
 * It allocates the memory for the number of elements and calls
 * splsm_7__msg__SPLSM__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_splsm_7
bool
splsm_7__msg__SPLSM__Sequence__init(splsm_7__msg__SPLSM__Sequence * array, size_t size);

/// Finalize array of msg/SPLSM messages.
/**
 * It calls
 * splsm_7__msg__SPLSM__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_splsm_7
void
splsm_7__msg__SPLSM__Sequence__fini(splsm_7__msg__SPLSM__Sequence * array);

/// Create array of msg/SPLSM messages.
/**
 * It allocates the memory for the array and calls
 * splsm_7__msg__SPLSM__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_splsm_7
splsm_7__msg__SPLSM__Sequence *
splsm_7__msg__SPLSM__Sequence__create(size_t size);

/// Destroy array of msg/SPLSM messages.
/**
 * It calls
 * splsm_7__msg__SPLSM__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_splsm_7
void
splsm_7__msg__SPLSM__Sequence__destroy(splsm_7__msg__SPLSM__Sequence * array);

/// Check for msg/SPLSM message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_splsm_7
bool
splsm_7__msg__SPLSM__Sequence__are_equal(const splsm_7__msg__SPLSM__Sequence * lhs, const splsm_7__msg__SPLSM__Sequence * rhs);

/// Copy an array of msg/SPLSM messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_splsm_7
bool
splsm_7__msg__SPLSM__Sequence__copy(
  const splsm_7__msg__SPLSM__Sequence * input,
  splsm_7__msg__SPLSM__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // SPLSM_7__MSG__DETAIL__SPLSM__FUNCTIONS_H_
